/* list10.c */
#include <stdio.h>
#include <stdlib.h>

typedef struct list {
	int count;
	char *name;
	struct list *next;
} list_t;


void show_list(list_t *head)
{
	list_t *ptr;

	for (ptr = head; ptr != NULL ; ptr = ptr->next) {
		printf("%*s", ptr->count, "");
		printf("%s\n", ptr->name);
	}
}

list_t *alloc_list(void)
{
	list_t *ptr;

	ptr = malloc(sizeof(struct list));
	if (ptr == NULL) {
		printf("܂\n");
		exit(1);
	}
	return (ptr);
}

void init_head(list_t *ptr)
{
	ptr->count = 0;
	ptr->name = "header";
	ptr->next = NULL;
}

int main(void)
{
	struct list head, *ptr, *ptr2;

	init_head(&head);

	ptr = alloc_list();
	ptr->count = 1;
	ptr->name = "next";
	ptr->next = NULL;
	head.next = ptr;

	ptr2 = alloc_list();
	ptr2->count = 2;
	ptr2->name = "tailer";
	ptr2->next = NULL;
	ptr->next = ptr2;

	show_list(&head);

	return 0;
}


